import type { Program } from 'typescript';
import type { ConfigSet } from '../config/config-set';
import type { ResolvedModulesMap, StringMap, TsCompilerInstance } from '../types';
export declare class TsCompiler implements TsCompilerInstance {
    readonly configSet: ConfigSet;
    readonly jestCacheFS: StringMap;
    protected readonly _logger;
    protected readonly _ts;
    private readonly _parsedTsConfig;
    private readonly _compilerCacheFS;
    protected readonly _initialCompilerOptions;
    protected _compilerOptions;
    private _cachedReadFile;
    private _projectVersion;
    private _languageService;
    program: Program | undefined;
    constructor(configSet: ConfigSet, jestCacheFS: StringMap);
    private _createLanguageService;
    getResolvedModulesMap(fileContent: string, fileName: string): ResolvedModulesMap;
    getCompiledOutput(fileContent: string, fileName: string, supportsStaticESM: boolean): string;
    private _isFileInCache;
    private _updateMemoryCache;
    private _doTypeChecking;
}
